/*
   Test application for SDUHexDump library
   By Sarah Dean
   Written: 18th June 2005
   Last updated: 18th June 2005
*/


#include <stdio.h>
#include <stdlib.h>

#include "SDUHexDump.h"


int main(void)
{
  char *printout;
  char *data;
  int dataSize;
  int i;
  int width;
  int offset;
  int printBufSize;


  width    = 8;   /* Number of columns in output */
  offset   = 0;   /* Offset within data to start prettyprinting from */
  dataSize = 512; /* Size of data to be prettyprinted */


  /* Allocate and fill a data buffer with data */
  data = malloc(dataSize);
  for (i = 0; i <= dataSize; i++)
    {
    data[i] = (char)(i % 256);
    }


  /* Estimated size of prettyprinted output */
  printBufSize = SDUPrettyPrintHexBufReq(
                                         dataSize,
                                         width
                                        );
  /* Allocate buffer for prettyprinted output */
  printout = malloc(printBufSize);

  /* Generate prettyprinted output */
  SDUPrettyPrintHex(
                    (unsigned char*)data,
                    offset,
                    dataSize,
                    printout,
                    printBufSize,
                    width
                   );

  /* Display prettprinted output */
  printf("%s\n", printout);

  /* Free prettprint buffer */
  free(printout);


  free(data);

  return 0;
}




